package ${packageName};

import ${modelPackageName}.${model};
import pro.shushi.pamirs.meta.annotation.Fun;
import pro.shushi.pamirs.meta.annotation.Function;
import pro.shushi.pamirs.meta.api.dto.condition.Pagination;
import pro.shushi.pamirs.meta.api.dto.wrapper.IWrapper;

import java.util.List;

/*
 * 接口必须@Fun才能在分布式下自动走远程
 * 方法上加@Function，才能在低代码工具中被在线替换
 */
@Fun(${modelQueryService}.FUN_NAMESPACE)
public interface ${modelQueryService} {

    String FUN_NAMESPACE = "${moduleNamePrefix}.${moduleName}.${modelQueryService}";
    /**
     * 分页查询接口
     * @param page
     * @param queryWrapper
     * @return
     */
    @Function
    Pagination<${model}> queryPage(Pagination<${model}> page, IWrapper<${model}> queryWrapper);

    /**
     * 集合查询接口
     * @param queryWrapper
     * @return
     */
    @Function
    List<${model}> queryListByWrapper(IWrapper<${model}> queryWrapper);

    /**
     * 集合查询接口
     * @param entity
     * @return
     */
    @Function
    List<${model}> queryListByEntity(${model} entity);

    /**
     * 根据查询条件count
     * @param queryWrapper
     * @return
    */
    @Function
    Long count(IWrapper<${model}> queryWrapper);

    /**
     * one查询接口
     * @param queryWrapper
     * @return
    */
    @Function
    ${model} queryOneByWrapper(IWrapper<${model}> queryWrapper);

    /**
     * one查询接口
     * @param query
     * @return
    */
    @Function
    ${model} queryOne(${model} query);

    <#if isCode() == true>
    /**
     * 根据code查询接口
     * @param code
     * @return
    */
    @Function
    ${model} queryByCode(String code);
    </#if>

    <#if isCode() == true>
    /**
     * 根据codes查询接口
     * @param codes
     * @return
    */
    @Function
    List<${model}> queryByCodes(List${"<"}String${">"} codes);
    </#if>

    /**
     * 根据id查询接口
     * @param id
     * @return
    */
    @Function
    ${model} queryById(Long id);

    /**
     * 根据ids查询接口
     * @param ids
     * @return
    */
    @Function
    List<${model}> queryByIds(List${"<"}Long${">"}ids);

}