package ${packageName};

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import pro.shushi.pamirs.framework.faas.utils.ArgUtils;
import pro.shushi.pamirs.meta.annotation.Action;
import pro.shushi.pamirs.meta.annotation.Function;
import pro.shushi.pamirs.meta.annotation.Model;
import pro.shushi.pamirs.meta.api.dto.condition.Pagination;
import pro.shushi.pamirs.meta.api.dto.wrapper.IWrapper;
import pro.shushi.pamirs.meta.constant.FunctionConstants;
import pro.shushi.pamirs.meta.enmu.FunctionOpenEnum;
import pro.shushi.pamirs.meta.enmu.FunctionTypeEnum;
import pro.shushi.pamirs.meta.enmu.ViewTypeEnum;

import ${apiPackage}.${modelQueryService};
import ${apiPackage}.${modelService};
import ${modelClass};
import ${proxyModelClass};

@Model.model(${proxyModel}.MODEL_MODEL)
@Component
public class ${proxyModel}Action {

    @Autowired
    private ${modelQueryService} ${modelQueryService?uncap_first};
    @Autowired
    private ${modelService} ${modelService?uncap_first};

    @Action.Advanced(name = FunctionConstants.create, managed = true)
    @Action(displayName = "确定", summary = "添加", bindingType = ViewTypeEnum.FORM)
    @Function(name = FunctionConstants.create)
    @Function.fun(FunctionConstants.create)
    public ${proxyModel} create(${proxyModel} data) {
        initData(data);
        ${model} dataConvert = ArgUtils.convert(${proxyModel}.MODEL_MODEL,${model}.MODEL_MODEL,data);
        ${model} result = ${modelService?uncap_first}.create(dataConvert);
        data.setId(result.getId());
        return data;
    }

    private void initData(${proxyModel} data) {
        //做一些初始化的事情，比如设置partnerId等等
    }

    @Action.Advanced(name = FunctionConstants.update, managed = true)
    @Action(displayName = "确定", summary = "修改", bindingType = ViewTypeEnum.FORM)
    @Function(name = FunctionConstants.update)
    @Function.fun(FunctionConstants.update)
    public ${proxyModel} update(${proxyModel} data) {
        initData(data);
        ${model} dataConvert = ArgUtils.convert(${proxyModel}.MODEL_MODEL,${model}.MODEL_MODEL,data);
        ${modelService?uncap_first}.update(dataConvert);
        return data;
    }

    @Function.Advanced(type = FunctionTypeEnum.QUERY)
    @Function.fun(FunctionConstants.queryPage)
    @Function(openLevel = {FunctionOpenEnum.API})
    public Pagination<${proxyModel}> queryPage(Pagination<${proxyModel}> page, IWrapper<${proxyModel}> queryWrapper) {
        //转化 page和queryWrapper
        Pagination<${model}> pageConvert = ArgUtils.convert(${proxyModel}.MODEL_MODEL,${model}.MODEL_MODEL,page);
        IWrapper<${model}> queryWrapperConvert = ArgUtils.convert(${proxyModel}.MODEL_MODEL,${model}.MODEL_MODEL,queryWrapper);
        Pagination<${model}> resultTmp = ${modelQueryService?uncap_first}.queryPage(pageConvert,queryWrapperConvert);
        //转化模型与代理模型
        Pagination<${proxyModel}> result = ArgUtils.convert(${model}.MODEL_MODEL,${proxyModel}.MODEL_MODEL,resultTmp);
        return result;
    }

    @Function.Advanced(type = FunctionTypeEnum.QUERY, managed = true)
    @Function(openLevel = FunctionOpenEnum.API)
    @Function.fun(FunctionConstants.queryByEntity)
    public ${proxyModel} queryOne(${proxyModel} query) {

        ${model} resultTmp = ${modelQueryService?uncap_first}.queryById(query.getId());
        //转化模型与代理模型
        ${proxyModel} result = ArgUtils.convert(${model}.MODEL_MODEL,${proxyModel}.MODEL_MODEL,resultTmp);
        //额外处理 ……
        return result;
    }
}
